window.MultipleChoiceTestData = {
    // Optional: Wie viele Versuche hat der/die Lernende (Standardwert: Unendlich)
    "maxTries": Infinity,

    // Optional: Soll statt der Anzahl an nötigen Versuchen bewertet werden, wie gut der/die Lernende abschneidet?
    "reportScore": false,

    // Optional: Sollen die Fragen nicht durchgemischt werden?
    "keepOrder": false,

    // Optional: Wie soll bewertet werden?
    // "questions"  → Standardwert, Frage kann entweder richtig sein (1 von 1 Punkt) oder falsch (0 von 1 Punkt)
    // "average"    → Durchschnittlicher Prozentsatz an richtig ausgewählten bzw. richtig nicht ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten bei jeder Frage
    // "choices"    → Anteil der richtig ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten
    "countMode": "questions",

    // Wie viele Fragen sollen für einen Test gezogen werden?
    "questionsPerTest": 5,

    // Welcher Anteil muss mindestens richtig sein, um zu bestehen?
    "threshold": 0.8,

    // Optional: Begrüßungstext
    "htmlIntro": "<p>Beantworte mindestens fünf Fragen richtig, um dieses Lernpaket erfolgreich abzuschließen.</p>",

    // Verfügbare statische Fragen
    "questions": [],

    // Fragengeneratoren
    "generators": [
        // Frage nach dem Vorzeichen
        function(arrFragen) {
            // Schon erzeugte Zufallszahlen
            var rands = [];
            // Zahl nach Vorgabe erzeugen
            function getNumber(
                boolRandom,     // Zufällige Zahl (true) oder Null (false)
                negative,       // Soll die Zahl negativ sein?
                showSign        // Unnötige Vorzeichen explizit anzeigen?
            ) {
                if (!boolRandom)
                    return 0;
                var r;
                do {
                    r = Math.floor(Math.random() * Math.pow(10, Math.floor(Math.random() * 3) + 1)) + 1;
                } while (rands.indexOf(r) != -1);
                rands.push(r);
                return (negative ? '-' : (showSign ? '+' : '')) + r;
            }

            var variants = [
                { "negative": true, "randomNumber": true, "showSign": true, "askSign": true },
                { "negative": false, "randomNumber": false, "showSign": false, "askSign": true },
                { "negative": false, "randomNumber": true, "showSign": true, "askSign": true },
                { "negative": false, "randomNumber": true, "showSign": false, "askSign": true },
                { "negative": true, "randomNumber": true, "showSign": true, "askSign": false },
                { "negative": false, "randomNumber": false, "showSign": false, "askSign": false },
                { "negative": false, "randomNumber": true, "showSign": true, "askSign": false },
                { "negative": false, "randomNumber": true, "showSign": false, "askSign": false }
            ];
            variants.map(function(o) {
                return {
                    "number": getNumber(o.randomNumber, o.negative, o.showSign),
                    "askSign": o.askSign,
                    "type": o.randomNumber ? (o.negative ? -1 : +1) : 0
                };
            }).map(function(o) {
                return {
                    "html": o.askSign ? ("Welches Vorzeichen hat die ganze Zahl <code>" + o.number + "</code>?") : ("Die ganze Zahl <code>" + o.number + "</code> ist…"),
                    "singlechoice": true,
                    "choices": (o.askSign ? ['Minus', 'Kein Vorzeichen', 'Plus', 'Plus und Minus'] : ['…eine negative Zahl', '…weder eine negative noch eine positive Zahl', '…eine positive Zahl', '…zugleich eine positive und eine negative Zahl']).map(function(text, index) {
                        return { "html": text, "correct": (index - 1 == o.type) };
                    })
                };
            }).map(function(q) {
                arrFragen.push(q);
            });
        }
    ]
}
